> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.talqora.com/api-reference/vector-storage-and-retrieval/upsert/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.talqora.com/_mcp/server. # Upsert Vectors POST https://api.talqora.com/v1/indexes/{index_id}/vectors Content-Type: application/json Reference: https://docs.talqora.com/api-reference/vector-storage-and-retrieval/upsert ## Authentication - `Authorization` header (bearer token, required) — Use a tq_live_ API key as a Bearer token. ## Request ### Path parameters - `index_id` (string, required) ### Headers - `Idempotency-Key` (string, required) ### Body (application/json) This endpoint expects an UpsertRequest. - `vectors` (list of VectorItem, required) ## Response ### 200 Successful Response - `upserted_count` (integer, required) - `inserted_count` (integer, required) - `status` ("ok", optional, default: ok) ## Errors ### 422 Unprocessable Entity Error Validation Error - `detail` (list of ValidationError, optional) ### 429 Too Many Requests Error Organization write rate limit exceeded - `error` (string, required) - `status` ("error", optional, default: error) - `message` (string, optional, nullable) - `code` (string, optional, nullable) - `field` (string, optional, nullable) - `expected` (string, optional, nullable) - `request_id` (string, optional, nullable) - `upgrade_url` (string, optional, nullable) ## Types ### VectorItem - `id` (string, required) - `values` (list of double, required) - `metadata` (map from string to any, optional) - `sparse_text` (string, optional, nullable) ### ValidationError - `loc` (list of ValidationErrorLocItems, required) - `msg` (string, required) - `type` (string, required) ### ValidationErrorLocItems ## Examples **Request** ```json { "vectors": [ { "id": "string", "values": [ 1.1 ] } ] } ``` **Response** ```json { "upserted_count": 1, "inserted_count": 1, "status": "ok" } ``` **SDK Code** ```python import requests url = "https://api.talqora.com/v1/indexes/index_id/vectors" payload = { "vectors": [ { "id": "string", "values": [1.1] } ] } headers = { "Idempotency-Key": "Idempotency-Key", "Authorization": "Bearer ", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.talqora.com/v1/indexes/index_id/vectors'; const options = { method: 'POST', headers: { 'Idempotency-Key': 'Idempotency-Key', Authorization: 'Bearer ', 'Content-Type': 'application/json' }, body: '{"vectors":[{"id":"string","values":[1.1]}]}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.talqora.com/v1/indexes/index_id/vectors" payload := strings.NewReader("{\n \"vectors\": [\n {\n \"id\": \"string\",\n \"values\": [\n 1.1\n ]\n }\n ]\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Idempotency-Key", "Idempotency-Key") req.Header.Add("Authorization", "Bearer ") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.talqora.com/v1/indexes/index_id/vectors") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Idempotency-Key"] = 'Idempotency-Key' request["Authorization"] = 'Bearer ' request["Content-Type"] = 'application/json' request.body = "{\n \"vectors\": [\n {\n \"id\": \"string\",\n \"values\": [\n 1.1\n ]\n }\n ]\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.talqora.com/v1/indexes/index_id/vectors") .header("Idempotency-Key", "Idempotency-Key") .header("Authorization", "Bearer ") .header("Content-Type", "application/json") .body("{\n \"vectors\": [\n {\n \"id\": \"string\",\n \"values\": [\n 1.1\n ]\n }\n ]\n}") .asString(); ``` ```php request('POST', 'https://api.talqora.com/v1/indexes/index_id/vectors', [ 'body' => '{ "vectors": [ { "id": "string", "values": [ 1.1 ] } ] }', 'headers' => [ 'Authorization' => 'Bearer ', 'Content-Type' => 'application/json', 'Idempotency-Key' => 'Idempotency-Key', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.talqora.com/v1/indexes/index_id/vectors"); var request = new RestRequest(Method.POST); request.AddHeader("Idempotency-Key", "Idempotency-Key"); request.AddHeader("Authorization", "Bearer "); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"vectors\": [\n {\n \"id\": \"string\",\n \"values\": [\n 1.1\n ]\n }\n ]\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Idempotency-Key": "Idempotency-Key", "Authorization": "Bearer ", "Content-Type": "application/json" ] let parameters = ["vectors": [ [ "id": "string", "values": [1.1] ] ]] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.talqora.com/v1/indexes/index_id/vectors")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```